import { decorateContextWithNeededData } from './index.js';

function monkeyPatchAnalyticsTrack() {
  var track = window.analytics.track;

  window.analytics.track = function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var event = args[0],
        properties = args[1],
        contextFromArgs = args[2],
        fn = args[3];
    decorateContextWithNeededData(contextFromArgs).then(function (context) {
      track.call(window.analytics, event, properties, context, fn);
    });
    return window.analytics;
  };
}

if (typeof window !== 'undefined') {
  if (!window.analytics) {
    console.warn('Segment Analytics is not loaded so patch is not applied.');
  } else {
    window.analytics.initialized ? monkeyPatchAnalyticsTrack() : window.analytics.ready(monkeyPatchAnalyticsTrack);
  }
}